﻿Ext.define('App.Control.Kivii.Finances.InvoiceTitle.Biz.NjzjCustomer.Form', {
    extend: 'System.Control.EntityForm',
    xtype: 'App.Control.Kivii.Finances.InvoiceTitle.Biz.NjzjCustomer.Form',
    entityType: 'Njzj.Connects.Entities.NjzjCustomer',
    layout: {
        type: 'responsivecolumn',
        states: {
            small: 1000,
            large: 0
        }
    },
    tbar: ['->', {
        text: '保存',
        iconCls: 'x-fa fa-save',
        iconAlign: 'left',
        handler: '_onSaveEntity',
        bind: {
            disabled: '{!formIsValid}'
        }
    }],
    defaults: {
        labelWidth: 60,
        labelAlign: 'right',
        xtype: 'textfield',
        margin: '0 10 10 10',
        responsiveCls: 'big-100 small-100'
    },
    items: [{
        fieldLabel: '部&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;门',
        xtype: 'comboSelector',
        dataSource: '/Restful/Njzj.Connects.Entities.NjzjDepartment/Query.json',
        keyField: 'DEPT',
        valueField: 'DEPTNAME',
        bind: {
            key: '{entity.dept}'
        },
        editable: false
        // allowBlank: false
    }, {
        fieldLabel: '公司名称',
        bind: '{entity.compname}',
        allowBlank: false
    }, {
        fieldLabel: '税&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;号',
        bind: '{entity.staxCode}',
        allowBlank: false,
        regex: /^[A-Z0-9]{15}$|^[A-Z0-9]{18}$|^[A-Z0-9]{20}$/,
        regexText: '请输入正确的税号，\n\n15位,18位,20位'
    }, {
        fieldLabel: '单位地址',
        bind: '{entity.adress}'
    }, {
        fieldLabel: '电话号码',
        bind: '{entity.cellPhoneNumber}'
    }, {
        fieldLabel: '开户银行',
        bind: '{entity.bankInformation}'
    }, {
        fieldLabel: '银行账户',
        bind: '{entity.accountHeader}'
    }],
    controller: {
        _onSaveEntity: function() {
            let _controller = this;
            let _view = _controller.getView();
            let _vm = _controller.getViewModel();
            Ext.Ajax.request({
                url: '/Restful/' + _view.entityType + '/Modify.json',
                jsonData: {
                    Item: _vm.data.entity
                },
                success: function(_response) {
                    var _rtns = Ext.decode(_response.responseText);
                    _view.fireEvent('entityModify', _view, _rtns.Results);
                },
                failure: function(_response) {
                    _view._isActivate && _view.unmask();
                }
            });
        }
    }
});