﻿Ext.define('App.Control.Kivii.Finances.InvoiceTitle.Selector', {
    extend: 'System.Control.EntitySelector',
    entityType: 'Kivii.Finances.Entities.InvoiceTitle',
    filter: {},
    selModel: false,
    store: {
        autoLoad: true
    },
    tbar: [{
        xtype: 'searchField',
        flex: 1,
        labelWidth: 60,
        queryField: 'CompanyName,TaxNumber',
        emptyText: '模糊搜索公司名称'
    }, {
        text: '添加',
        iconCls: 'x-fa fa-plus',
        iconAlign: 'left',
        handler: '_onCreateInvoiceTitle'
    }],
    columns: [{
        xtype: 'rownumberer',
        align: 'center',
    }, {
        text: '公司名称',
        dataIndex: 'CompanyName',
        width: 150
    }, {
        text: '税号',
        dataIndex: 'TaxNumber',
        width: 160
    }, {
        text: '公司地址',
        dataIndex: 'CompanyAddress',
        minWidth:100,
        flex: 1
    }, {
        text: '电话号码',
        dataIndex: 'Phone',
        width: 120
    }, {
        text: '开户银行',
        dataIndex: 'BankName',
        width: 200
    }, {
        text: '银行账户',
        dataIndex: 'BankAccount',
        width: 150
    }],
    controller: {
        _onCreateInvoiceTitle: function(_ctrl) {
            let _controllor = this;
            let _view = _controllor.getView();
            let _invoiceTitle = Ext.create('App.Control.Kivii.Finances.InvoiceTitle.Form');
            let _win = Ext.create('Ext.window.Window', {
                layout: 'fit',
                // title: _ctrl.text,
                // iconCls: 'x-fa fa-money',
                iconAlign: 'left',
                autoScroll: true,
                width: 560,
                height: 380,
                modal: true,
                resizable: false,
                items: [_invoiceTitle]
            });
            _win.show();
            _invoiceTitle.on('entityCreated', function() {
                _win.close();
            });
            _win.on('close', function() {
                _view.getStore().reload();
            });
        }
    }
});