﻿using Kivii.DataAnnotations;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Finances.Entities
{
    [Api(Description = "结算分组")]
    [Alias(Configs.TableNameSettlementGroup)]
    public class SettlementGroup : EntityWithMetadata, IEntityInAssemblyDb
    {
        /// <summary>
        /// 一般用于所属部门使用
        /// </summary>
        [DefaultEmptyGuid]
        public Guid OwnerKvid { get; set; }

        [StringLength(500)]
        public string OwnerName { get; set; }

        [ApiMember(Description = "付方单位")]
        [IgnoreUpdate]
        [StringLength(100), Required, Unique]
        public string PayerName { get; set; }

        [ApiMember(Description = "类型")]
        [InternalSetter]
        [StringLength(500), Required]
        public string Type { get; set; }

        [ApiMember(Description = "结算金额总和")]
        [InternalSetter]
        [DecimalLength(15, 2), Default(0)]
        public decimal Amount { get; set; }

        [ApiMember(Description = "结算数量总和")]
        [InternalSetter]
        [Default(0)]
        public int Quantity { get; set; }
    }
}
