﻿using Kivii.Finances.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Finances
{
    public static class SettlementExtension
    {

        public static Settlement Offset (this Settlement settlement,string remark)
        {
            settlement.ThrowIfNull("付款记录不能为空!");
            (settlement.OffsetKvid != Guid.Empty).ThrowIfTrue("收项已冲账");
            (settlement.Currency == CurrencyUnit.Unsupported).ThrowIfTrue("不支持的货币单位");

            #region pay冲账
            var newSettlementKvid = Guid.NewGuid();
            settlement.OffsetKvid = newSettlementKvid;
            settlement.AddOnlyProperties(o => o.OffsetKvid);
            settlement.Remark = $"{remark}";
            settlement.AddOnlyProperties(o => o.Remark);

            //新建一个和原来一样的
            var offsetSettlement = new Settlement();
            offsetSettlement.PopulateWith(settlement);
            offsetSettlement.OffsetKvid = settlement.Kvid;//新的冲帐关联用原来的Kvid
            offsetSettlement.Kvid = newSettlementKvid;
            offsetSettlement.SerialNumber = settlement.SerialNumber.IsNullOrEmpty() ? "" : ("-" + settlement.SerialNumber);
            offsetSettlement.Remark = $"{remark}";
            offsetSettlement.AmountPlan = 0 - offsetSettlement.AmountPlan;
            offsetSettlement.AmountPayment = 0 - offsetSettlement.AmountPayment;
            offsetSettlement.Amount = 0 - offsetSettlement.Amount;//反向值
            #endregion

            return offsetSettlement;
        }
    }
}
