﻿using Kivii.Finances.Entities;
using Kivii.Web;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Finances.Transforms
{
    #region CRUDQ
    [RequiresAnyRole(SystemRoles.Everyone)]
    public class InvoiceTitleCreate : RestfulCreate<InvoiceTitle>
    {
        public override bool OnPreRestfulCreate(IRequest req, IResponse res, IDbConnection dbConnection, IRestfulCreateResponse<InvoiceTitle> rtns)
        {
            Item.CompanyName = Item.CompanyName.Replace("(", "（");
            Item.CompanyName = Item.CompanyName.Replace(")", "）");
            Item.CompanyName = Item.CompanyName.Replace(" ", "");
            return base.OnPreRestfulCreate(req, res, dbConnection, rtns);
        }
    }

    [RequiresAnyRole(SystemRoles.Everyone)]
    public class InvoiceTitleUpdate : RestfulUpdate<InvoiceTitle>
    {
        public override bool OnPreRestfulUpdate(IRequest req, IResponse res, IDbConnection dbConnection, IRestfulUpdateResponse<InvoiceTitle> rtns)
        {
            if (!Item.CompanyName.IsNullOrEmpty())
            {
                Item.CompanyName = Item.CompanyName.Replace("(", "（");
                Item.CompanyName = Item.CompanyName.Replace(")", "）");
                Item.CompanyName = Item.CompanyName.Replace(" ", "");
                Item.AddOnlyProperties(o => o.CompanyName);
            }
            return base.OnPreRestfulUpdate(req, res, dbConnection, rtns);
        }
    }

    [RequiresAnyRole(SystemRoles.Everyone)]
    public class InvoiceTitleRead : RestfulRead<InvoiceTitle>
    {
    }

    [RequiresAnyRole(SystemRoles.Everyone)]
    public class InvoiceTitleQuery : RestfulQuery<InvoiceTitle>
    {
    }

    [RequiresAnyRole(SystemRoles.Everyone)]
    public class InvoiceTitleDelete : RestfulDelete<InvoiceTitle>
    {
    }
    #endregion
}
